#if !defined(SYSTEM_H)
#define SYSTEM_H TRUE
/*========================================================================
*
* Name - %M%
*
* Version:     %I%
*
* ccsid:       %W% - %G% %U%
* from:        %F%
* date:        %H% %T%
*
* %Q%
*
* Description: Types and interfaces to OS and run-time library
*
*========================================================================*/

#if defined(AIX)
#define FLG_AIX_UNIX TRUE
#endif

#if defined(linux)
#define FLG_LINUX_UNIX TRUE
#endif

#if defined(sun)
#ifndef __SVR4
#define FLG_SUN_UNIX TRUE
#else /* __SVR4 */
#define FLG_SOLARIS_UNIX TRUE
#endif /*  __SVR4 */
#if defined(mc68020)
#define sun3 TRUE
#endif
#if defined(sparc)
#define sun4 TRUE
#endif
#if defined(sun386)
/* #define sun_roadrunner TRUE */
#endif
#endif /*  defined(sun) */

#if defined(ultrix)
#define FLG_ULTRIX_UNIX TRUE
#endif

#if defined(sony_news)
#define FLG_NEWS_UNIX TRUE
#endif

#if defined(hpux)
#define FLG_HPUX_UNIX TRUE
#define _TERMIOS_INCLUDED TRUE
#endif

#if defined(sgi)
#define FLG_SGI_UNIX TRUE
#define _TERMIOS_INCLUDED TRUE
#endif

/* LINTLIBRARY */
#include <stdio.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/errno.h>
#include <sys/file.h>
#include <sys/resource.h>
#include <sys/stat.h>
#include <signal.h>
#if defined(_POSIX_SOURCE) || defined(_POSIX_C_SOURCE)
#include <sys/wait.h>
#else
#define _POSIX_SOURCE
#define _POSIX_C_SOURCE 3
#include <sys/wait.h>
#undef _POSIX_SOURCE
#undef _POSIX_C_SOURCE
#endif /* defined(_POSIX_SOURCE) || defined(_POSIX_C_SOURCE) */
#include <sys/ioctl.h>
#include <fcntl.h>
#include <pwd.h>
#if !defined(FLG_SOLARIS_UNIX) && !defined(FLG_LINUX_UNIX)
#include <strings.h>
#else
#include <unistd.h>
#endif

#if defined(FLG_AIX_UNIX)
#include <sys/termio.h>
#include <sys/pty.h>
#include <dirent.h>

#define SIGCHLD SIGCLD
#define X_OK   1 /* executable by caller */
#define W_OK   2 /* writable by caller */
#define R_OK   4 /* readable by caller */
#endif

/*
#if !defined(FLG_AIX_UNIX) && !defined(FLG_HPUX_UNIX) && !defined(FLG_SOLARIS_UNIX) && !defined(FLG_LINUX_UNIX)
#include <sys/dir.h>

struct direct *readdir();
#endif
*/

#include <dirent.h>

#if defined(FLG_HPUX_UNIX) || defined(FLG_SGI_UNIX) || defined(FLG_SOLARIS_UNIX) || defined(FLG_LINUX_UNIX)
#if defined(FLG_SOLARIS_UNIX)
#include <sys/stropts.h>
#endif
#include <sys/termio.h>
#ifndef TIOCGWINSZ
#include <sys/ioctl.h>
#endif

#define index strchr
#define rindex strrchr
#define getdtablesize() FD_SETSIZE
#endif

/**********************************************************
   Various System Declarations Missing on Many Systems...
***********************************************************/

double atof();

#if defined(FLG_HPUX_UNIX)
char *getcwd();
#else
char *getwd();
#endif

char *getenv();
#if !defined(FLG_SGI_UNIX)
struct passwd *getpwuid();
struct passwd *getpwnam();
#endif
char *gets();
uid_t getuid();

char *index();

char *malloc();
/*
char *memcpy();
char *memset();
DIR  *opendir();
*/
FILE *popen();
#ifndef FLG_LINUX_UNIX
int psignal();
#endif

char *rindex();

/*
#if defined(FLG_HPUX_UNIX)
int sprintf();
#else
char *sprintf();
#endif
*/

char *strcat();

int strncmp();
char *strcpy();

char *tgoto();
char *tgetstr();

#if defined(FLG_SUN_UNIX) /* size_t and malloc() defined inconsistently */
#define MALLOC(x) calloc((unsigned)(x),1)
#else
#define MALLOC(x) calloc((size_t)(x),1)
#endif

#define FREE(x)   free((char *)(x))

#if defined(FLG_AIX_UNIX) || defined(FLG_SGI_UNIX)
typedef struct termio TermInfoSType;
typedef struct dirent SysDirectSType;
typedef struct winsize WinInfoSType;
#else
#if defined(FLG_HPUX_UNIX) || defined(FLG_SOLARIS_UNIX) || defined(FLG_LINUX_UNIX)
typedef struct termios TermInfoSType;
typedef struct dirent SysDirectSType;
typedef struct winsize WinInfoSType;
#else /* BSD */
typedef struct sgttyb TermInfoSType;
typedef struct dirent SysDirectSType;
typedef struct winsize WinInfoSType;
#endif
#endif

#if defined(FLG_AIX_UNIX) || defined(sony_news)
typedef int UnixSignalFuncType();
#else /* ultrix, hp-ux, sunos */
typedef void UnixSignalFuncType();
#endif

UnixSignalFuncType *signal();

extern int errno;

#if !defined(FLG_HPUX_UNIX) && !defined(FLG_LINUX_UNIX)
extern char *sys_siglist[];
#endif

#endif
